DECLARE SUB SET.OUTPUT1 (Hex.Address!, OUT5!, OUT4!, OUT3!, OUT2!, OUT1!, A.HOME.DIR!, B.HOME.DIR!)
DECLARE SUB SET.OUTPUT2 (Hex.Address!, OUT10!, OUT9!, OUT8!, OUT7!, OUT6!, C.HOME.DIR!, D.HOME.DIR!)
DECLARE FUNCTION GET.INPUT! (Hex.Address!, Input.Number!)
DECLARE SUB INITIALIZE (Hex.Address!, X.NUMBER!)
DECLARE SUB SLEW.AT.BASE.CCW (Hex.Address!, X.NUMBER!)
DECLARE SUB WAIT.FOR.STOP (Hx.Address!, X.NUMBER!)
DECLARE SUB ONE.AT.MAX.CW (Hex.Address!, X.NUMBER!)
DECLARE SUB POSITION (Hex.Address!, X.NUMBER!, Setting!)
DECLARE SUB RAMP.TO.BASE.CW (Hex.Address!, X.NUMBER!)
DECLARE SUB SET.POSITION (Hex.Address!, X.NUMBER!, Setting!)
DECLARE SUB STOP.MOTION (Hex.Address!, X.NUMBER!)
DECLARE SUB LIMIT.CONTROL (Hex.Address!, X.NUMBER!, SOFT!, MARKER!, HOME!)
DECLARE SUB MOTION (Hex.Address!, X.NUMBER!, Base.Speed!, Max.Speed!, Ramp.Value!)
DECLARE SUB SET.ENCODER (Hex.Address!, X.NUMBER!, Setting!)
DECLARE SUB GO.CCW (Hex.Address!, X.NUMBER!)
DECLARE SUB GO.CW (Hex.Address!, X.NUMBER!)
DECLARE SUB INDEX (Hex.Address!, X.NUMBER!, Setting!)
DECLARE FUNCTION READ.ENCODER! (Hex.Address!, X.NUMBER!)
DECLARE FUNCTION READ.POSITION! (Hex.Address!, X.NUMBER!)
DECLARE FUNCTION SOFT.INPUT.CCW! (Hex.Address!, X.NUMBER!)
DECLARE FUNCTION SOFT.INPUT.CW! (Hex.Address!, X.NUMBER!)
DECLARE FUNCTION BUSY! (H.Address!, X.NUMBER!)
DECLARE FUNCTION HARD.INPUT.CCW! (Hex.Address!, X.NUMBER!)
DECLARE FUNCTION HARD.INPUT.CW! (Hex.Address!, X.NUMBER!)
DECLARE FUNCTION HOME.INPUT! (Hex.Address!, X.NUMBER!)
DECLARE SUB GET.LO.MID.HI (VALUE!, HIBYTE!, MIDBYTE!, LOBYTE!)
DECLARE FUNCTION GET.BASE! (Base.Speed!, Max.Speed!, Ramp.Value!)
DECLARE FUNCTION GET.MAX! (Base.Speed!, Max.Speed!, Ramp.Value!)
DECLARE FUNCTION GET.RAMP! (Base.Speed!, Max.Speed!, Ramp.Value!)

'ANAHIEIM AUTOMATION
'PROGRAM: CLCISUB1.BAS
'DATE: 7/9/93
'BY: ALAN HARMON
                      
'THIS PROGRAM CONTAINS SUBROUTINES AND FUNCTIONS TO BE USED WITH
'AHAHEIM AUTOMATION'S CLCI2000 SERIES OF INDEXERS.
'THE DESCRIPTIONS FOR ALL THESE SUBROUTINES AND FUNCTIONS ARE LISTED
'IN THE CLCI2000 MANUAL.
'CALL 714/992-6990 FOR MORE INFORMATION

'TO USE THIS FILE YOU NEED TO LOAD IT INTO YOUR MAIN PROGRAM
'  FROM THE MAIN PROGRAM IN QUICKBASIC:
'  CHOOSE ALT-F (FILE)
'  CHOOSE L (LOAD FILE)
'  CHOOSE CLCISUBS.BAS (THIS PROGRAM)

'BE SURE TO DECLARE THE SUBS AND FUNCTIONS YOU ARE USING
'YOU MIGHT WANT TO COPY ALL THE DECLARE STATEMENTS TO YOUR MAIN PROGRAM.

FUNCTION BUSY (H.Address, X.NUMBER)
       ADDRESS = H.Address + 12 + X.NUMBER * 4

       OUT ADDRESS, 128 + 10
       A = INP(ADDRESS)
       IF A >= 128 THEN A = A - 128
       IF A >= 64 THEN
                BUSY = 1        'BUSY
        ELSE
                BUSY = 0        'NOT BUSY
        END IF
END FUNCTION

FUNCTION GET.BASE (Base.Speed, Max.Speed, Ramp.Value)

         OPTIMUM.FACTOR = 300! * 16383 / Max.Speed
         FACTOR = INT(OPTIMUM.FACTOR)
         IF FACTOR < 2 THEN FACTOR = 2
         IF FACTOR > 16383 THEN FACTOR = 16383

         MAX.SETTING = INT(Max.Speed * FACTOR / 300)
                IF MAX.SETTING > 16383 THEN MAX.SETTING = 16383

'this finds the RAMP
         RAMP.SETTING = INT((150! * 9830400) / (Ramp.Value * FACTOR))
         IF RAMP.SETTING < 1 THEN RAMP.SETTING = 1
         IF RAMP.SETTING > 32767 THEN RAMP.SETTING = 32767

         ACTUAL.RAMP = (150! * 9830400) / (RAMP.SETTING * FACTOR)

         BASE.SETTING = INT(Base.Speed * FACTOR / 300)
         IF BASE.SETTING < 1 THEN BASE.SETTING = 1

   GET.BASE = 300! * BASE.SETTING / FACTOR


END FUNCTION

FUNCTION GET.INPUT (Hex.Address, Input.Number)
       IF Input.Number > 5 THEN
                ADDRESS = Hex.Address + 8
                Input.Number = Input.Number - 5
       ELSE
                ADDRESS = Hex.Address
       END IF

       OUT ADDRESS, 8
       VALUE = INP(ADDRESS)
       VALUE = VALUE - 128 - 64 - 32
      
            IF Input.Number = 5 THEN
                IF VALUE >= 16 THEN
                        GET.INPUT = 0
                ELSE
                        GET.INPUT = 1
                END IF
            END IF
      
       VALUE = VALUE MOD 16
            IF Input.Number = 4 THEN
                IF VALUE >= 8 THEN
                        GET.INPUT = 0
                ELSE
                        GET.INPUT = 1
                END IF
            END IF
      
       VALUE = VALUE MOD 8
            IF Input.Number = 3 THEN
                IF VALUE >= 4 THEN
                        GET.INPUT = 0
                ELSE
                        GET.INPUT = 1
                END IF
            END IF

       VALUE = VALUE MOD 4
            IF Input.Number = 2 THEN
                IF VALUE >= 2 THEN
                        GET.INPUT = 0
                ELSE
                        GET.INPUT = 1
                END IF
            END IF

       VALUE = VALUE MOD 2
            IF Input.Number = 1 THEN
                IF VALUE = 1 THEN
                        GET.INPUT = 0
                ELSE
                        GET.INPUT = 1
                END IF
            END IF

END FUNCTION

SUB GET.LO.MID.HI (VALUE, HIBYTE, MIDBYTE, LOBYTE)
      
        HIBYTE = INT(VALUE / 65536)
        MIDBYTE = INT(VALUE / 256) MOD 256
        LOBYTE = VALUE MOD 256

END SUB

FUNCTION GET.MAX (Base.Speed, Max.Speed, Ramp.Value)
'this will find the optimum FACTOR

         OPTIMUM.FACTOR = 300! * 16383 / Max.Speed
         FACTOR = INT(OPTIMUM.FACTOR)
         IF FACTOR < 2 THEN FACTOR = 2
         IF FACTOR > 16383 THEN FACTOR = 16383
 
        MAX.SETTING = INT(Max.Speed * FACTOR / 300)
                IF MAX.SETTING > 16383 THEN MAX.SETTING = 16383

   GET.MAX = 300! * MAX.SETTING / FACTOR

END FUNCTION

FUNCTION GET.RAMP (Base.Speed, Max.Speed, Ramp.Value)

         OPTIMUM.FACTOR = 300! * 16383 / Max.Speed
         FACTOR = INT(OPTIMUM.FACTOR)
         IF FACTOR < 2 THEN FACTOR = 2
         IF FACTOR > 16383 THEN FACTOR = 16383

        MAX.SETTING = INT(Max.Speed * FACTOR / 300)
                IF MAX.SETTING > 16383 THEN MAX.SETTING = 16383
        RAMP.SETTING = INT((150! * 9830400) / (Ramp.Value * FACTOR))
        IF RAMP.SETTING < 1 THEN RAMP.SETTING = 1
        IF RAMP.SETTING > 32767 THEN RAMP.SETTING = 32767

        GET.RAMP = (150! * 9830400) / (RAMP.SETTING * FACTOR)

END FUNCTION

SUB GO.CCW (Hex.Address, X.NUMBER)
       ADDRESS = Hex.Address + 12 + X.NUMBER * 4

       OUT ADDRESS, 65
       OUT ADDRESS, 23
END SUB

SUB GO.CW (Hex.Address, X.NUMBER)
       ADDRESS = Hex.Address + 12 + X.NUMBER * 4

       OUT ADDRESS, 65
       OUT ADDRESS, 19
END SUB

FUNCTION HARD.INPUT.CCW (Hex.Address, X.NUMBER)
       ADDRESS = Hex.Address + 12 + X.NUMBER * 4

       OUT ADDRESS, 131
       LIMITS = INP(ADDRESS + 1)
       LIMITS = LIMITS - 128
        IF LIMITS \ 64 = 1 THEN LIMITS = LIMITS - 64
        IF LIMITS \ 32 = 1 THEN LIMITS = LIMITS - 32
        IF LIMITS \ 16 = 1 THEN LIMITS = LIMITS - 16
        IF LIMITS \ 8 = 1 THEN LIMITS = LIMITS - 8
        IF LIMITS \ 4 = 1 THEN LIMITS = LIMITS - 4
        IF LIMITS \ 2 = 1 THEN
                HARD.INPUT.CCW = 1
        ELSE
                HARD.INPUT.CCW = 0
        END IF
END FUNCTION

FUNCTION HARD.INPUT.CW (Hex.Address, X.NUMBER)
       ADDRESS = Hex.Address + 12 + X.NUMBER * 4
       OUT ADDRESS, 131
       LIMITS = INP(ADDRESS + 1)
                                        '128: RDY
                                        ' 64: EZ
                                        ' 32: ALM (HOME MULTIPLEXED)
                                        ' 16: ORG (TIED TO EZ)
                                        '  8: -SD (-SOFT LIMIT)
                                        '  4: +SD (+SOFT LIMIT)
                                        '  2: -EL (-HARD LIMIT)
                                        '  1: +EL (+HARD LIMIT)

        LIMITS = LIMITS - 128
        IF LIMITS \ 64 = 1 THEN LIMITS = LIMITS - 64
        IF LIMITS \ 32 = 1 THEN LIMITS = LIMITS - 32
        IF LIMITS \ 16 = 1 THEN LIMITS = LIMITS - 16
        IF LIMITS \ 8 = 1 THEN LIMITS = LIMITS - 8
        IF LIMITS \ 4 = 1 THEN LIMITS = LIMITS - 4
        IF LIMITS \ 2 = 1 THEN LIMITS = LIMITS - 2
        IF LIMITS = 1 THEN
                HARD.INPUT.CW = 1
        ELSE
                HARD.INPUT.CW = 0
        END IF

END FUNCTION

SUB HOME.CCW (Hex.Address, X.NUMBER)
       ADDRESS = Hex.Address + 12 + X.NUMBER * 4

       OUT ADDRESS, 64
       OUT ADDRESS, 23
END SUB

SUB HOME.CW (Hex.Address, X.NUMBER)
       ADDRESS = Hex.Address + 12 + X.NUMBER * 4

       OUT ADDRESS, 64
       OUT ADDRESS, 19
END SUB

FUNCTION HOME.INPUT (Hex.Address, X.NUMBER)
       ADDRESS = Hex.Address + 12 + X.NUMBER * 4

       OUT ADDRESS, 131
       LIMITS = INP(ADDRESS + 1)
      
       PRINT LIMITS;

       LIMITS = LIMITS - 128
       IF LIMITS \ 64 = 1 THEN LIMITS = LIMITS - 64
       IF LIMITS \ 32 = 1 THEN
                HOME.INPUT = 1
       ELSE
                HOME.INPUT = 0
       END IF
END FUNCTION

SUB INDEX (Hex.Address, X.NUMBER, Setting)
  ADDRESS = Hex.Address + 12 + X.NUMBER * 4

  CALL GET.LO.MID.HI(Setting, HI, MID, LO)
  OUT ADDRESS, 128 + 0
  OUT ADDRESS + 1, LO
  OUT ADDRESS + 2, MID
  OUT ADDRESS + 3, HI
END SUB

SUB INITIALIZE (Hex.Address, X.NUMBER)
       ADDRESS = Hex.Address + 12 + X.NUMBER * 4
              
INDEX ADDRESS, X.NUMBER, 1000
MOTION ADDRESS, X.NUMBER, 200, 4000, 200000
SET.ENCODER ADDRESS, X.NUMBER, 0
LIMIT.CONTROL ADDRESS, X.NUMBER, 1, 1, 1
SET.OUTPUT1 ADDRESS, 0, 0, 0, 0, 0, 1, 1
SET.OUTPUT2 ADDRESS, 0, 0, 0, 0, 0, 1, 1

END SUB

SUB LIMIT.CONTROL (Hex.Address, X.NUMBER, SOFT, MARKER, HOME)
        ADDRESS = Hex.Address + 12 + X.NUMBER * 4

        VALUE = 128 + 64 + 1
        IF HOME = 1 THEN VALUE = VALUE + 8
        IF MARKER = 1 THEN VALUE = VALUE + 4
        IF SOFT = 1 THEN VALUE = VALUE + 2
        OUT ADDRESS, VALUE
END SUB

SUB MOTION (Hex.Address, X.NUMBER, Base.Speed, Max.Speed, Ramp.Value)
  ADDRESS = Hex.Address + 12 + X.NUMBER * 4

         OPTIMUM.FACTOR = 300! * 16383 / Max.Speed
         FACTOR = INT(OPTIMUM.FACTOR)
         IF FACTOR < 2 THEN FACTOR = 2
         IF FACTOR > 16383 THEN FACTOR = 16383
                CALL GET.LO.MID.HI(FACTOR, HI, MID, LO)
                OUT ADDRESS, 128 + 4
                OUT ADDRESS + 1, LO
                OUT ADDRESS + 2, MID
                OUT ADDRESS + 3, HI
        MAX.SETTING = INT(Max.Speed * FACTOR / 300)
            IF MAX.SETTING > 16383 THEN MAX.SETTING = 16383
                CALL GET.LO.MID.HI(MAX.SETTING, HI, MID, LO)
                OUT ADDRESS, 128 + 2
                OUT ADDRESS + 1, LO
                OUT ADDRESS + 2, MID
                OUT ADDRESS + 3, HI
        RAMP.SETTING = INT((150! * 9830400) / (Ramp.Value * FACTOR))
        IF RAMP.SETTING < 1 THEN RAMP.SETTING = 1
        IF RAMP.SETTING > 32767 THEN RAMP.SETTING = 32767
  CALL GET.LO.MID.HI(RAMP.SETTING, HI, MID, LO)
                OUT ADDRESS, 128 + 3
                OUT ADDRESS + 1, LO
                OUT ADDRESS + 2, MID
                OUT ADDRESS + 3, HI
        BASE.SETTING = INT(Base.Speed * FACTOR / 300)
        IF BASE.SETTING < 1 THEN BASE.SETTING = 1
                CALL GET.LO.MID.HI(BASE.SETTING, HI, MID, LO)
                OUT ADDRESS, 128 + 1
                OUT ADDRESS + 1, LO
                OUT ADDRESS + 2, MID
                OUT ADDRESS + 3, HI
END SUB

SUB ONE.AT.MAX.CCW (Hex.Address, X.NUMBER)
       ADDRESS = Hex.Address + 12 + X.NUMBER * 4

       OUT ADDRESS, 29
END SUB

SUB ONE.AT.MAX.CW (Hex.Address, X.NUMBER)
       ADDRESS = Hex.Address + 12 + X.NUMBER * 4

       OUT ADDRESS, 25
END SUB

SUB ORIGIN.INDEX.CCW (Hex.Address, X.NUMBER)
       ADDRESS = Hex.Address + 12 + X.NUMBER * 4

       OUT ADDRESS, 114
       OUT ADDRESS, 23
END SUB

SUB ORIGIN.INDEX.CW (Hex.Address, X.NUMBER)
       ADDRESS = Hex.Address + 12 + X.NUMBER * 4

       OUT ADDRESS, 114
       OUT ADDRESS, 18
END SUB

SUB PAUSE (B)
A = TIMER
WHILE TIMER - A < B
WEND
END SUB

SUB POSITION (Hex.Address, X.NUMBER, Setting)
       ADDRESS = Hex.Address + 12 + X.NUMBER * 4

    Num.to.Index = Setting - READ.POSITION(Hex.Address, X.NUMBER)
    IF Num.to.Index > 0 THEN
        INDEX Hex.Address, X.NUMBER, Num.to.Index
        GO.CW Hex.Address, X.NUMBER
    ELSE
        INDEX Hex.Address, X.NUMBER, ABS(Num.to.Index)
        GO.CCW Hex.Address, X.NUMBER
    END IF
END SUB

SUB RAMP.TO.BASE.CCW (Hex.Address, X.NUMBER)
       ADDRESS = Hex.Address + 12 + X.NUMBER * 4

       OUT ADDRESS, 6
END SUB

SUB RAMP.TO.BASE.CW (Hex.Address, X.NUMBER)
       ADDRESS = Hex.Address + 12 + X.NUMBER * 4

       OUT ADDRESS, 2
END SUB

SUB RAMP.TO.STOP.CCW (Hex.Address, X.NUMBER)
       ADDRESS = Hex.Address + 12 + X.NUMBER * 4
       OUT ADDRESS, 14
END SUB

SUB RAMP.TO.STOP.CW (Hex.Address, X.NUMBER)
       ADDRESS = Hex.Address + 12 + X.NUMBER * 4
       OUT ADDRESS, 10
END SUB

FUNCTION READ.ENCODER (Hex.Address, X.NUMBER)
       ADDRESS = Hex.Address + 12 + X.NUMBER * 4

       OUT ADDRESS, 128 + 8
       OUT ADDRESS + 1, 1
       OUT ADDRESS + 2, 44
     
       OUT ADDRESS, 128 + 13
        BB = INP(ADDRESS + 1)
        CC = INP(ADDRESS + 2)
        DD = INP(ADDRESS + 3)
       Encoder.Value = BB + CC * 256 + DD * 256 * 256
    IF Encoder.Value > 8388608 THEN
                Encoder.Value = (Encoder.Value - 16777216)
    END IF
    READ.ENCODER = Encoder.Value
END FUNCTION

FUNCTION READ.POSITION (Hex.Address, X.NUMBER)
       ADDRESS = Hex.Address + 12 + X.NUMBER * 4

       OUT ADDRESS, 128 + 8
       OUT ADDRESS + 1, 1
       OUT ADDRESS + 2, 44
       OUT ADDRESS, 128 + 12
        BB = INP(ADDRESS + 1)
        CC = INP(ADDRESS + 2)
        DD = INP(ADDRESS + 3)
       READ.POSITION = BB + CC * 256 + DD * 256 * 256
END FUNCTION

SUB SET.ENCODER (Hex.Address, X.NUMBER, Setting)
  ADDRESS = Hex.Address + 12 + X.NUMBER * 4
 
  CALL GET.LO.MID.HI(Setting, HI, MID, LO)
  OUT ADDRESS, 128 + 7
  OUT ADDRESS + 1, LO
  OUT ADDRESS + 2, MID
  OUT ADDRESS + 3, HI
END SUB

SUB SET.OUTPUT1 (Hex.Address, OUT5, OUT4, OUT3, OUT2, OUT1, A.HOME.DIR, B.HOME.DIR)
        ' a 1 for A.HOME.DIR = CW
        ' a 0 for A.HOME.DIR = CCW
   ADDRESS = Hex.Address + 4

   VALUE = OUT5 * 16 + OUT4 * 8 + OUT3 * 4 + OUT2 * 2 + OUT1
   IF A.HOME.DIR = 0 THEN VALUE = VALUE + 64
   IF B.HOME.DIR = 0 THEN VALUE = VALUE + 128
   OUT ADDRESS, VALUE
END SUB

SUB SET.OUTPUT2 (Hex.Address, OUT10, OUT9, OUT8, OUT7, OUT6, C.HOME.DIR, D.HOME.DIR)
        ' a 1 for A.HOME.DIR = CW
        ' a 0 for A.HOME.DIR = CCW
       ADDRESS = Hex.Address + 12

   VALUE = OUT10 * 16 + OUT9 * 8 + OUT8 * 4 + OUT7 * 2 + OUT6
   IF C.HOME.DIR = 0 THEN VALUE = VALUE + 64
   IF D.HOME.DIR = 0 THEN VALUE = VALUE + 128
   OUT ADDRESS, VALUE

END SUB

SUB SET.POSITION (Hex.Address, X.NUMBER, Setting)
  ADDRESS = Hex.Address + 12 + X.NUMBER * 4

  CALL GET.LO.MID.HI(Setting, HI, MID, LO)
  OUT ADDRESS, 128 + 6
  OUT ADDRESS + 1, LO
  OUT ADDRESS + 2, MID
  OUT ADDRESS + 3, HI
END SUB

SUB SLEW.AT.BASE.CCW (Hex.Address, X.NUMBER)
       ADDRESS = Hex.Address + 12 + X.NUMBER * 4

       OUT ADDRESS, 64
       OUT ADDRESS, 20
END SUB

SUB SLEW.AT.BASE.CW (Hex.Address, X.NUMBER)
       ADDRESS = Hex.Address + 12 + X.NUMBER * 4

       OUT ADDRESS, 64
       OUT ADDRESS, 16
END SUB

FUNCTION SOFT.INPUT.CCW (Hex.Address, X.NUMBER)
       ADDRESS = Hex.Address + 12 + X.NUMBER * 4

       OUT ADDRESS, 131
       LIMITS = INP(ADDRESS + 1)
       LIMITS = LIMITS - 128
       IF LIMITS \ 64 = 1 THEN LIMITS = LIMITS - 64
       IF LIMITS \ 32 = 1 THEN LIMITS = LIMITS - 32
       IF LIMITS \ 16 = 1 THEN LIMITS = LIMITS - 16
       IF LIMITS \ 8 = 1 THEN
                SOFT.INPUT.CCW = 1
        ELSE
                SOFT.INPUT.CCW = 0
        END IF
    
END FUNCTION

FUNCTION SOFT.INPUT.CW (Hex.Address, X.NUMBER)
       ADDRESS = Hex.Address + 12 + X.NUMBER * 4

       OUT ADDRESS, 131
       LIMITS = INP(ADDRESS + 1)
       LIMITS = LIMITS - 128
       IF LIMITS \ 64 = 1 THEN LIMITS = LIMITS - 64
       IF LIMITS \ 32 = 1 THEN LIMITS = LIMITS - 32
       IF LIMITS \ 16 = 1 THEN LIMITS = LIMITS - 16
       IF LIMITS \ 8 = 1 THEN LIMITS = LIMITS - 8
       IF LIMITS \ 4 = 1 THEN
                SOFT.INPUT.CW = 1
        ELSE
                SOFT.INPUT.CW = 0
        END IF
     
END FUNCTION

SUB STOP.MOTION (Hex.Address, X.NUMBER)
       ADDRESS = Hex.Address + 12 + X.NUMBER * 4

       IF BUSY(Hex.Address, X.NUMBER) = 1 THEN OUT ADDRESS, 8
END SUB

SUB WAIT.FOR.STOP (Hx.Address, X.NUMBER)
       WHILE BUSY(Hx.Address, X.NUMBER) = 1
       WEND
END SUB

